// Luca Burger

import java.util.ArrayList;
import java.util.Scanner;

public class DoppelteBuchhaltung {
    Scanner scan = new Scanner(System.in);
    private ArrayList<Konto> konten = new ArrayList<Konto>();

    public DoppelteBuchhaltung() {
        // wow
    }

    public void habenKontoErstellen(String kontonummer, String kontobezeichnung) {
        HabenKonto konto = new HabenKonto(kontonummer, kontobezeichnung);
        konten.add(konto);
    }

    public void sollKontoErstellen(String kontonummer, String kontobezeichnung, double zinssatz) {
        SollKonto konto = new SollKonto(kontonummer, kontobezeichnung, zinssatz);
        konten.add(konto);
    }

    public void buchungDurchfuehren(String kontonummerSoll, String kontonummerHaben, double betrag,
            String beschreibung) {
        Konto sollKonto = getKontoNachNummer(kontonummerSoll);
        Konto habenKonto = getKontoNachNummer(kontonummerHaben);
        try {
            sollKonto.transaktionDurchfuehren(betrag, beschreibung);
            habenKonto.transaktionDurchfuehren(betrag * -1, beschreibung);
            sollKonto.buchen(betrag);
            habenKonto.buchen(betrag * -1);
        } catch (Exception e) {
            System.out.println("error: " + e);
        }
    }

    public void alleKontenAnzeigen() {
        for (Konto konto : konten) {
            String text;
            if (konto instanceof SollKonto) {
                text = "Kontonummer: " + konto.getKontonummer() + ", Bezeichnung: " + konto.getKontobezeichnung()
                        + ", Typ: Sollkonto, Saldo: " + konto.getSaldo();
            } else {
                text = "Kontonummer: " + konto.getKontonummer() + ", Bezeichnung: " + konto.getKontobezeichnung()
                        + ", Typ: Habenkonto, Saldo: " + konto.getSaldo();
            }
            System.out.println(text);
        }
    }

    public void bewegungenAufKontoAnzeigen(String kontonummer) {
        Konto konto = getKontoNachNummer(kontonummer);
        ArrayList<Transaktion> transaktionen = konto.getTransaktionsverlauf();
        for (Transaktion transaktion : transaktionen) {
            String text = "Kontonummer für Kontobewegung eingeben:\n" + konto.getKontonummer()
                    + "\n Bewegungen auf Konto: " + konto.getKontobezeichnung() + "\n";
        }
    }

    private Konto getKontoNachNummer(String kontonummer) {
        for (Konto konto : konten) {
            if (kontonummer == konto.getKontonummer()) {
                return konto;
            }
        }
        System.out.println("Konto nicht gefunden");
        return null; // error
    }
}
